#!/bin/bash


# error exit
error_exit() {
    /usr/local/bin/ledcont errfastblink
    exit 1
}


# Stop the services.
/etc/rc.d/init.d/S99usbhdmng stop >& /dev/null
/etc/rc.d/init.d/S99button_daemon stop >& /dev/null
/etc/rc.d/init.d/S98UPnPResponder stop > /dev/null 2>&1
/etc/rc.d/init.d/shutdown stop >& /dev/null
/etc/rc.d/init.d/crond stop >& /dev/null
/etc/rc.d/init.d/smb stop >& /dev/null
/etc/rc.d/init.d/portmap stop >& /dev/null
/etc/rc.d/init.d/network stop >& /dev/null
sync

mount -o remount,rw %root% /
[ $? != 0 ] && error_exit


# Backup setting files
for n in inittab sudoers rc.d/rcS; do
	f=/etc/$n
	if [ -f $f ]; then
		/bin/cp $f $f.backup
		[ $? != 0 ] && error_exit
	fi
done

# Add sudoers
s='/etc/sudoers'
if [ -f $s -a $(/bin/grep -c landisk $s) = 0 ]; then
	echo '' >> $s
	echo 'landisk	ALL=(ALL)	ALL' >> $s
fi

# Add inittab
s='/etc/inittab'
if [ -f $s -a $(/bin/grep -c telnetd $s) = 0 ]; then
	echo '' >> $s
	echo '::respawn:/usr/sbin/in.telnetd -debug 23' >> $s
fi

# Add inittab
s='/etc/rc.d/rcS'
if [ -f $s -a $(/bin/grep -c kogiidena-usl5p-telnetd $s) = 0 ]; then
	echo '# modified by kogiidena-usl5p-telnetd-update.tgz script' >> $s
	echo 'mount -o remount,rw /' >> $s
fi

# Copy Files.
tar xpzf /mnt/ram1/update-files.tar.gz -C /
[ $? != 0 ] && error_exit

# Remount root in ro-mode.
sync
mount -o remount,ro %root% /

# Remove updator files
rm -rf /mnt/ram1/update.tgz
rm -rf /mnt/ram1/update-files.tar.gz

# Reboot
sync
/home/LANDISK/scripts/powerctrl.sh reboot

exit 0

